﻿Type=Activity
Version=1.92
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim pnlTicket As Panel
	Dim btnSaveTicket As Button
	Dim pnlKeyBoard As Panel
	Dim ButtonUp As GradientDrawable
	Dim ClrsUp(2) As Int
	Dim ButtonDown As GradientDrawable
	Dim ClrsDown(2) As Int
	Dim SaveButtonUp As GradientDrawable
	Dim SaveButtonUpClr(2) As Int
	Dim SaveButtonDown As GradientDrawable
	Dim SaveButtonDownClr(2) As Int
	Dim TicketListRow() As String
	Dim AdView1 As AdView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If Main.BackButtonPressed Then
		Activity.Finish
		ExitApplication
	End If

	'the next 2 lines are for AdMob which means the AdMob library must be included
	AdView1.Initialize("Ad", "a1501a5a4525fc7") 'publisher id that you received from AdMob.
	Activity.AddView(AdView1, 0dip, 0dip, 320dip, 50dip)

	'colours for buttons 1 to 49 - Up is light to dark blue from top to bottom
	'                              Down is light to dark red from top to bottom
	ClrsUp(0) = Colors.RGB(150,150,150)
	ClrsUp(1) = Colors.Blue
	ButtonUp.Initialize("TOP_BOTTOM",ClrsUp)
	ButtonUp.CornerRadius = 25dip
	ClrsDown(0) = Colors.RGB(255,142,142)
	ClrsDown(1) = Colors.Red
	ButtonDown.Initialize("TOP_BOTTOM",ClrsDown)
	ButtonDown.CornerRadius = 25dip
	
	'the colours for the Save Ticket button are the same as the buttons
	'on previous screens
	'		Up is light grey to Blue from Top to Bottom
	'		Down is light grey to Blue from Bottom to Top
	SaveButtonUpClr(0) = Colors.RGB(150,150,150)
	SaveButtonUpClr(1) = Colors.Blue
	SaveButtonUp.Initialize("TOP_BOTTOM",SaveButtonUpClr)
	SaveButtonUp.CornerRadius = 5dip
	SaveButtonDownClr(0) = Colors.Blue
	SaveButtonDownClr(1) = Colors.RGB(150,150,150)
	SaveButtonDown.Initialize("TOP_BOTTOM",SaveButtonDownClr)
	SaveButtonDown.CornerRadius = 5dip
	
	'initialize the panel that holds the 6 numbers that make up the new or edited ticket
	pnlTicket.Initialize("pnlTicket")	
	Activity.AddView(pnlTicket, 50%x - (140dip * Main.scale), 14%y, 280dip * Main.scale, 42dip * Main.scale)
	pnlTicket.Color = Colors.Black
	Dim TicketNumberLeft As Int
	TicketNumberLeft = 4dip  * Main.scale
	For x = 0 To 5
		Dim TicketNumber As Label
		TicketNumber.Initialize("TicketNumber")
		TicketNumber.Gravity = Gravity.CENTER
		TicketNumber.Color = Colors.Blue
		TicketNumber.TextColor = Colors.White
'		pnlTicket.AddView(TicketNumber,TicketNumberLeft,4dip  * Main.scale, 42dip  * Main.scale, 42dip  * Main.scale)
		pnlTicket.AddView(TicketNumber,TicketNumberLeft,0, 42dip  * Main.scale, 42dip  * Main.scale)
		TicketNumberLeft = TicketNumberLeft + (46dip * Main.scale)
	Next
	
	'initialize the panel that will hold the buttons numbered 1 to 49
	pnlKeyBoard.Initialize("pnlKeyBoard")	
	Activity.AddView(pnlKeyBoard, 50%x - (154dip * Main.scale), 100%y - (238dip * Main.scale), 308dip * Main.scale, 238dip * Main.scale)
	pnlKeyBoard.Color = Colors.Black
	Dim ButtonHeight As Int
	Dim ButtonWidth As Int
	Dim ButtonLeft As Int
	Dim ButtonTop As Int
	ButtonHeight = 30dip * Main.scale
	ButtonWidth  = 40dip * Main.scale
	ButtonLeft = 2dip * Main.scale
	ButtonTop = 0
	For x = 1 To 49
		Dim BtnN As Button
		BtnN.Initialize("btnN")
		BtnN.Text = x
		BtnN.Tag = x
		BtnN.Gravity = Gravity.CENTER
		BtnN.TextColor = Colors.White
		If Density < 1 Then
			BtnN.TextSize = 10dip
		Else
			BtnN.TextSize = 10
		End If
		BtnN.Background = ButtonUp
		pnlKeyBoard.AddView(BtnN, ButtonLeft, ButtonTop, ButtonWidth, ButtonHeight)
		If (x Mod 7 = 0) Then
			ButtonTop = ButtonTop + (34dip * Main.scale)
			ButtonLeft = 2dip * Main.scale
		Else
			ButtonLeft = ButtonLeft + (44dip * Main.scale)
		End If
	Next
	'the Save Ticket button is positioned halfway between the ticket panel and the keyboard panel & it's 48dip high
	Dim SaveButtonTop As Int
	SaveButtonTop = (pnlTicket.Top + pnlTicket.Height) + ((pnlKeyBoard.Top - (pnlTicket.Top + pnlTicket.Height)) / 2) - (20dip * Main.scale)
	btnSaveTicket.Initialize("btnSaveTicket")
	btnSaveTicket.Text = "Save Ticket"
	btnSaveTicket.Gravity = Gravity.CENTER
	btnSaveTicket.Background = SaveButtonUp
	btnSaveTicket.TextColor = Colors.White
	Activity.AddView(btnSaveTicket, 50%x - (60dip * Main.scale), SaveButtonTop, 120dip * Main.scale, 40dip * Main.scale)
	AddMenus
End Sub

Sub Activity_Resume
	If Main.BackButtonPressed Then
		Activity.Finish
		ExitApplication
	End If

 	AdView1.LoadAd 'loads an ad

	'set all the buttons on the keyboard to blue (ie not pressed)
	For x = 1 To 49
		Dim b As Button
		b = pnlKeyBoard.GetView(x - 1)
		b.Background = ButtonUp
	Next
	'if this routine was entered as a result of btnChangeTicket being clicked in EditTickets then
	'an existing ticket is being changed so show its contents on this screen at the top & set the background
	'of the ticket numbers to red (from blue)
	'if this routine was entered as a result of btnAddTicket being clicked in EditTickets then
	'set the 6 numbers at the top of the screen to blue with no text
	For x = 0 To 5
		Dim TicketNumber As Label
		TicketNumber = pnlTicket.GetView(x)
		If Main.AddIndicator = False Then	
			TicketNumber.Text = EditTickets.SelectedTicket(x)
			TicketNumber.Color = Colors.Red
			'set the 6 numbers that make up the ticket to pink in the 49 number array
			Dim b As Button
			b = pnlKeyBoard.GetView(TicketNumber.Text - 1)
			b.Background = ButtonDown
		Else
			TicketNumber.Text = ""
			TicketNumber.Color = Colors.Blue
		End If
	Next

	'hide the Save Ticket button until all 6 numbers have been entered
	If EditTickets.SelectedTicket(5) = 0 Then
		btnSaveTicket.Visible = False
	Else
		btnSaveTicket.Visible = True
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	'save the TicketList to the csv file
	If Main.TicketList.Size = 0 Then
		File.WriteString(Main.FolderName, Main.csvFileName, "")
	Else
		Main.StringUtils1.SaveCSV(Main.FolderName, Main.csvFileName, ",",Main.TicketList)
	End If
End Sub
Sub AddMenus
	Activity.AddMenuItem("Help", "Menu")
End Sub
Sub Menu_Click
  Dim txt As String
  txt = Sender
  Select txt
  	Case "Help"
			If Main.AddIndicator Then
				Msgbox("When you're adding a ticket the 6 boxes at the top of the screen will be empty." & CRLF & _
			"Click on the numbers on the 'keyboard' in the lower part of the screen to add your numbers." & CRLF & _
			"When 6 numbers have been entered the 'Save Ticket' button will appear." & CRLF & _
			"Click on that to save your ticket and return to the editing screen","Lotto Checker Help")
			Else
				Msgbox("To change a number on a ticket, first click that number on the 'keyboard' in the lower part of the screen." & CRLF & _
			"Then click on the number you want to replace it with." & CRLF & _
			"When the ticket has 6 numbers the 'Save Ticket' button will appear." & CRLF & _
			"Click on that to save your ticket and return to the editing screen","Lotto Checker Help")
			End If
  End Select
End Sub

Sub BtnN_Click
	Dim Send As Button
	Send = Sender
	If Send.Background = ButtonUp Then
		AddTicketNumber(Send.Tag)
	Else
		RemoveTicketNumber(Send.Tag)
	End If
	SortTicketNumbers
End Sub

Sub AddTicketNumber(TicketNo As Int)
  'this Method is called when one of the numbers on the screen (NumberSelected, 1 - 49) is clicked
  Dim b As Button
	Dim l As Label
	Dim z As Int
	'on the keyboard the numbers range from 1 to 49 but as views on the pnlKeyBoard panel they will range from 0 to 48
	b = pnlKeyBoard.GetView(TicketNo - 1)
  z = 0
  'look at the row of 6 numbers above the block of 49 numbers on the screen
  'and populate the first empty one with the number that has been clicked
  Do While z <= 5
		l = pnlTicket.GetView(z)
    If l.Text = "" Then
      l.Text = TicketNo
			l.Color = Colors.Red
			b.Background = ButtonDown
      Exit
    Else
      z = z + 1
    End If
  Loop
  
  If z > 5 Then
		b.Background = ButtonUp
    Msgbox("Only 6 numbers allowed","")
  End If
End Sub
Sub RemoveTicketNumber(TicketNo As Int)
  Dim b As Button
	Dim l As Label
  Dim z As Int
	b = pnlKeyBoard.GetView(TicketNo - 1)
  For z = 0 To 5
		l = pnlTicket.GetView(z)
    If TicketNo = l.Text Then
      l.Text = ""
			l.Color = Colors.Blue
			b.Background = ButtonUp
      Exit 'For
    End If
  Next 'z
End Sub
Sub SortTicketNumbers
  Dim TempNo As Int
  Dim y, z As Int
  Dim IntTicketNo(6) As Int
  Dim l As Label
	
  For z = 0 To 5
		l = pnlTicket.GetView(z)
    If l.Text = "" Then
      IntTicketNo(z) = 99
    Else
      IntTicketNo(z) = l.Text
		End If
  Next 'z
  
  For z = 0 To 5
    TempNo = IntTicketNo(z)
    y = z
    Do While y > 0 AND IntTicketNo(y - 1) > TempNo
      IntTicketNo(y) = IntTicketNo(y - 1)
      y = y - 1
    Loop
    IntTicketNo(y) = TempNo
  Next 'z
  
  For z = 0 To 5
		l = pnlTicket.GetView(z)
    If IntTicketNo(z) = 99 Then
      l.Text = ""
			l.Color = Colors.Blue
    Else
      l.Text = IntTicketNo(z)
			l.Color = Colors.Red
    End If
  Next 'z
	If l.Text = "" Then
		btnSaveTicket.Visible = False
	Else
		btnSaveTicket.Visible = True
	End If
	
End Sub
Sub btnSaveTicket_Click
	Dim Values(Main.NumberOfColumns) As String	'nb main.numberofcolumns contains 7 whereas edittickets.numberofcolumns contains 6
  Dim l As Label
	For z = 0 To 5
		l = pnlTicket.GetView(z)
		EditTickets.SelectedTicket(z) = l.Text
		Values(z) = l.Text
	Next
	Values(6) = 0
	If Main.AddIndicator Then
		'add the newly created ticket to the end of the list
		Main.TicketList.Add(Values)
	Else
		'change the selected ticket
		Main.TicketList.Set(EditTickets.SelectedRow,Values)
	End If
	StartActivity(EditTickets)
End Sub
Sub btnSaveTicket_Down
	btnSaveTicket.Background = SaveButtonDown
End Sub
Sub btnSaveTicket_Up
	btnSaveTicket.Background = SaveButtonUp
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	Log("Activity_KeyPress entered - KeyCode = " & KeyCode)
	'if the back key is pressed on this screen we want to return to the previous screen
	'but we also need to finish this activity otherwise it starts up if the back key is
	'pressed on a subsequent screen
	Select KeyCode 
		Case KeyCodes.KEYCODE_BACK
			Activity.Finish
			Return False
		Case KeyCodes.KEYCODE_MENU
			Menu_Click
			Return False
		Case Else
			Return True
	End Select
End Sub